#include <stdio.h>
#include "..\..\..\..\drivers\TCPIPCore.h"
#include "loopback.h"
#include "lcd.h"

#define	MAX_BUF_SIZE	8192		// Maximum receive buffer size

/*******************************************************************************************/
/* If you have QFN64pin package W7100A, have to use 'USE_QFN64' definition in TCPIPcore.h  */
/*******************************************************************************************/

uint8 xdata * data_buf =(uint8 xdata *)0x7000;	// Position of receive buffer

void main()
{
	uint8 xdata str[15];

	Init_iMCU();		// Initialize   iMCUW7100    
	Init_Network(); 	// Initialize   Network Configuration
	lcd_init(); 		// Initialize   TextLCD 			 	
 
	// for LCD	
	sprintf(str, "%.3bu.%.3bu.%.3bu.%.3bu",
			 IINCHIP_READ (SIPR0+0),  IINCHIP_READ (SIPR0+1), 
			 IINCHIP_READ (SIPR0+2),  IINCHIP_READ (SIPR0+3));
	evb_set_lcd_text(0,(uint8 *) "iMCU7100EVB");
	evb_set_lcd_text(1, str);

	//start message
	printf("\r\n-------LOOPBACK_TEST_START--------\r\n");
	while(1){
			//loopback_tcpc(0, 3000, data_buf, 0);
			loopback_tcpc(0, 80, data_buf, 0);
			/*	
			loopback_tcpc(1, 5000, data_buf, 0);	
			loopback_tcpc(2, 5000, data_buf, 0);	
			loopback_tcpc(3, 5000, data_buf, 0);	
			loopback_tcpc(4, 5000, data_buf, 0);	
			loopback_tcpc(5, 5000, data_buf, 0);	
			loopback_tcpc(6, 5000, data_buf, 0);	
			loopback_tcpc(7, 5000, data_buf, 0);	 
			*/
	}

}
